package com.getsnappy.filter;

import java.io.IOException;
import java.io.StringWriter;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class NoCacheFilter implements Filter {
   private FilterConfig filterConfig = null;
   public void init(FilterConfig filterConfig) 
      throws ServletException {
      this.filterConfig = filterConfig;
   }
   public void destroy() {
      this.filterConfig = null;
   }
   public void doFilter(ServletRequest request,
      ServletResponse response, FilterChain chain) 
      throws IOException, ServletException {
      if (filterConfig == null)
         return;
      
      if (response instanceof HttpServletResponse) {
         HttpServletResponse httpResponse = (HttpServletResponse)response;
         if (!response.isCommitted()) {
            httpResponse.addHeader("Pragma", "no-cache");
//          httpResponse.addHeader("Cache-control", "no-cache, must-revalidate");      
            // Causes opera to behave nicer
            httpResponse.addHeader("Cache-control", "private, no-cache");      
         }
      }
      chain.doFilter(request, response);
   }

}
