package com.getsnappy.snappyj;

import java.net.URLDecoder;
import java.util.Hashtable;
import java.util.StringTokenizer;

import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletRequest;

class CommonUtil {
   static Hashtable<String,String[]> parseQueryString(String s)
   {
      String valArray[] = null;
      if (s == null)
         throw new IllegalArgumentException("null");
      Hashtable ht = new Hashtable();
      if (s.equals("undefined"))
         return null;
      StringBuffer sb = new StringBuffer();
      String key;
      for (StringTokenizer st = new StringTokenizer(s, "&"); st.hasMoreTokens(); ht.put(key, valArray)) {
         String pair = st.nextToken();
         int pos = pair.indexOf('=');
         if (pos == -1)
            throw new IllegalArgumentException("what no = sign in query string (" + pair + ") - (" + s + ")");
         key = parseName(pair.substring(0, pos), sb);
         String val = parseName(pair.substring(pos + 1, pair.length()), sb);
         if (ht.containsKey(key)) {
            String oldVals[] = (String[]) ht.get(key);
            valArray = new String[oldVals.length + 1];
            for (int i = 0; i < oldVals.length; i++)
               valArray[i] = oldVals[i];

            valArray[oldVals.length] = val;
         } else {
            valArray = new String[1];
            valArray[0] = val;
         }
      }

      return ht;
   }

   private static String parseName(String s, StringBuffer sb)
   {
      sb.setLength(0);
      for (int i = 0; i < s.length(); i++) {
         char c = s.charAt(i);
         switch (c) {
         case 43: // '+'
            sb.append(' ');
            break;

         case 37: // '%'
            try {
               sb.append((char) Integer.parseInt(s.substring(i + 1, i + 3), 16));
               i += 2;
               break;
            } catch (NumberFormatException e) {
               throw new IllegalArgumentException("Invalid % at " + (i + 1)  + " in query string (" + s + ")");
            } catch (StringIndexOutOfBoundsException e) {
               String rest = s.substring(i);
               sb.append(rest);
               if (rest.length() == 2)
                  i++;
            }
            break;

         default:
            sb.append(c);
            break;
         }
      }

      return sb.toString();
   } 
   
   static String getCookieValue(HttpServletRequest request, String key) {
      Cookie[] cookies = request.getCookies();
      if (cookies == null) 
         return null;
      
      String value = null;
      for (int i = 0;i < cookies.length;i++) {
         if (cookies[i].getName().equals(key)) {
            value = URLDecoder.decode(cookies[i].getValue());
            break;
         }
         
      }
      
      return value;
   }
   
   private static final String BACKUP_QUERY_STRING = "com.getsnappy.w20.backupQueryString";
   /**
    * Just like it sounds.  Use these values if request.getParameter returns null.
    * used in conjunction with getParameter below.
    * 
    * @param request
    * @param queryString
    */
   static void setBackupQueryString(HttpServletRequest request, String queryString) {
      try {
         request.setAttribute(BACKUP_QUERY_STRING, parseQueryString(queryString));
      } catch (Exception e) { e.printStackTrace(); }
      
   }
   
   /**
    * This is specail function used the provide an alternate method of receiving arguments.  
    * In most cases arguments from cookies set during javascript calls are then loaded in
    * jsp in order to support reloads and history.
    * 
    * @param request
    * @param parameterName
    * @return
    */
   static String getParameter(HttpServletRequest request, String parameterName) {
      String result = null;
      
      Hashtable<String, String[]> internalParameters = (Hashtable<String, String[]>)request.getAttribute(BACKUP_QUERY_STRING);
      if (internalParameters != null) {
         try {
            String[] resultArray = internalParameters.get(parameterName);
            if (resultArray == null || resultArray.length == 0) {
               result = null;
            } else {
//               System.err.println("->Cookie/Internal Match for " + parameterName + ": " + resultArray[0]+ "<-");
               result = resultArray[0];
            }
         } catch (Exception e) {

            e.printStackTrace();
         }
      }
      String resultParam = request.getParameter(parameterName);
      if (resultParam != null) {
         result = resultParam;
      }
      
      return result;
   }

 
}
