package com.getsnappy.snappyj;

import java.io.IOException;
import java.io.Writer;

import com.sun.org.apache.xpath.internal.functions.Function;

/**
 * This loading indicator  will apply the opaque png "/images/grey.png" screenwide and
 * then load /images/loadingBox.png and attempt to keep it centered in the screen
 *
 * @author brian
 *
 */
public class ContextBlockingAnimatedGifLoadingIndicator extends JavaScriptLoadingIndicator {
   private static ContextBlockingAnimatedGifLoadingIndicator indicator;
   private String contextId;
   
   public ContextBlockingAnimatedGifLoadingIndicator(String contextId) { 
      this.contextId = contextId;
   }
   /**
    * This function will apply the opaque png "/images/grey.png" screenwide and
    * then load /images/loadingBox.png and attempt to keep centered in the screen
    * 
    * @throws IOException 
    */
   @Override
   public void jsStart(Writer out) throws IOException {
      
      out.write("function () {\n");


//      out.write("var scroll = getScrollXY();\n");
//      out.write("var windowSize = getWindowSize();\n");
      out.write("   if (w20.context." + contextId + ".loading == undefined) {\n");
      out.write("      var context = document.getElementById(" + StringUtil.jsQuote(contextId) + ");\n");
//      out.write("      context.style.background = 'url(/images/grey.png) repeat';\n");
      out.write("      var contextLeft = '' + (context.clientWidth / 2 - 60) + 'px';\n");
      out.write("      var contextTop = '' + (context.clientHeight / 2 - 62) + 'px';\n");
      
      out.write("      var loadingBox2 = document.createElement('div');\n");
      out.write("      loadingBox2.style.position = 'absolute';\n");
      out.write("      loadingBox2.style.marginLeft = contextLeft;\n");
      out.write("      loadingBox2.style.marginTop = contextTop;\n");
      out.write("      loadingBox2.style.background = 'url(/images/loadingBox.png) no-repeat';\n");
      out.write("      loadingBox2.style.width='120px';\n");
      out.write("      loadingBox2.style.height='125px';\n");
 

      out.write("      var animatedLoading = document.createElement(\"div\");\n");
      out.write("      animatedLoading.style.position = 'relative';\n");
      out.write("      animatedLoading.style.top = '10px';\n");
      out.write("      animatedLoading.style.left = '10px';\n");
      out.write("      animatedLoading.style.background = 'url(/images/animatedLoading.gif) no-repeat';\n");
      out.write("      animatedLoading.style.width='100px'; \n");
      out.write("      animatedLoading.style.height='100px';\n");
      out.write("      loadingBox2.appendChild(animatedLoading);\n");


      out.write("      if (!context.firstChild) {\n");
      out.write("         context.appendChild(loadingBox2);\n");
      out.write("      } else {\n");
      out.write("         context.insertBefore(loadingBox2,context.firstChild);\n");
      out.write("      }\n");
      out.write("      context.loading = loadingBox2;\n");
      out.write("   }\n");
      out.write("}");
   }
   
   @Override
   public void jsFinish(Writer out) throws IOException {
      out.write("function () {\n");
      out.write("   var context = document.getElementById(" + StringUtil.jsQuote(contextId) + ");\n");
      out.write("   if (context != undefined && context.loading) {\n");
      out.write("      var loading = context.loading;\n");
      out.write("      context.loading = undefined;\n");
//      out.write("      context.style.background = 'transparent'\n");
//      out.write("      alert('removing indicator');\n");
//      out.write("      context.removeChild(context.loading);\n");
 //     out.write("      alert('removed!');\n");
      out.write("   }\n");
      out.write("}");
   }
}
