package com.getsnappy.snappyj;

import java.util.Calendar;
import java.util.Date;
import java.util.Vector;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;


import com.getsnappy.util.ReflectionCache.ClassCache;

/**
 * Every DynamicContext instance is backed by a CategoryChooserBean bean
 * 
 * @author brian
 *
 */
public class DynamicContextBean extends JavaScriptBean
{
   // The contextId is use to prefix everything external to this object
   // (cookies, beans)
   private String contextId;
   
   public static class Attributes {
      public static String CLASS_NAME = "className";
      
   }
   
   
   private static Vector<String> applicationVariables = new Vector<String>();
   private static Vector<Class> applicationVariableTypes = new Vector<Class>();
   static {
      applicationVariables.add(Attributes.CLASS_NAME);
      applicationVariableTypes.add(String.class);
   }

   @Override
   protected Vector<String> getApplicationVariables() {
      // TODO Auto-generated method stub
      
      return applicationVariables;
   }

   @Override
   protected Vector<Class> getApplicationVariableTypes() {
      // TODO Auto-generated method stub
      
      return applicationVariableTypes;
   }

   
   protected static String COOKIE_NAME = "CategoryChooserBean";
   @Override
   public String getCookieName() {
      // TODO Auto-generated method stub
      return contextId + COOKIE_NAME;
   }

   /**
    * load up the CategoryChooserBean with the giving contextId.  This contextId is appended to the cookie name, 
    * js bean name, and all attributes.  This contextId allows multiple DynamicContext's to coexists on the same
    * web page.
    * 
    * @param request
    * @param response
    * @param contextId - this parameter is prefixed to attributes, so that we can support mulitple DynamicContext's
    */
   public DynamicContextBean(HttpServletRequest request,HttpServletResponse response, String contextId, String defaultApplication) {
      this.contextId = contextId;
      load(request,response);
      if (get(Attributes.CLASS_NAME) == null) {
         set(Attributes.CLASS_NAME,defaultApplication);
      }
   }

   public String getClassName()
   {
      return (String)get(Attributes.CLASS_NAME);
   }
   
   void setClassName(String className) {
      set(Attributes.CLASS_NAME, className);
   }
   


   @Override
   public String getJavaScriptBeanName() {
      return contextId + "Bean";
   }

   
}
