package com.getsnappy.snappyj.examples;

import java.io.IOException;
import java.io.Writer;

import com.getsnappy.w20.JavaScriptLoadingIndicator;
import com.getsnappy.w20.StringUtil;
import com.sun.org.apache.xpath.internal.functions.Function;

/**
 * This loading indicator  will apply the opaque png "/images/grey.png" screenwide and
 * then load /images/loadingBox.png and attempt to keep it centered in the screen
 *
 * @author brian
 *
 */
public class GroovyLoadingIndicator extends JavaScriptLoadingIndicator {
   private String contextId;
   
   public GroovyLoadingIndicator(String contextId) { 
      this.contextId = contextId;
   }
   /**
    * This function will apply the opaque png "/images/grey.png" screenwide and
    * then load /images/loadingBox.png and attempt to keep centered in the screen
    * 
    * @throws IOException 
    */
   @Override
   public void jsStart(Writer out) throws IOException {
      
      out.write("function () {\n");


      out.write("   var context = document.getElementById(" + StringUtil.jsQuote(contextId) + ");\n");
      out.write("   if (context.firstChild && context.firstChild.id != " + StringUtil.jsQuote(contextId + "LI") + ") {\n");
//      out.write("      context.style.background = 'url(/images/grey.png) repeat';\n");
      out.write("      var contextLeft = '' + (context.clientWidth / 2 - 60) + 'px';\n");
      out.write("      var contextTop = '' + (context.clientHeight / 2 - 62) + 'px';\n");
      
      out.write("      var loadingBox2 = document.createElement('div');\n");
      out.write("      loadingBox2.style.position = 'absolute';\n");
      out.write("      loadingBox2.style.marginLeft = contextLeft;\n");
      out.write("      loadingBox2.style.marginTop = contextTop;\n");
      out.write("      loadingBox2.style.background = 'url(/images/loadingBox.png) no-repeat';\n");
      out.write("      loadingBox2.style.width='120px';\n");
      out.write("      loadingBox2.style.height='125px';\n");
      out.write("      loadingBox2.id=" + StringUtil.jsQuote(contextId + "LI") + ";\n");


      out.write("      var animatedLoading = document.createElement(\"div\");\n");
      out.write("      animatedLoading.style.position = 'relative';\n");
      out.write("      animatedLoading.style.top = '10px';\n");
      out.write("      animatedLoading.style.left = '10px';\n");
      out.write("      animatedLoading.style.background = 'url(/images/animatedLoading.gif) no-repeat';\n");
      out.write("      animatedLoading.style.width='100px'; \n");
      out.write("      animatedLoading.style.height='100px';\n");
      out.write("      loadingBox2.appendChild(animatedLoading);\n");


      out.write("      if (!context.firstChild) {\n");
      out.write("         context.appendChild(loadingBox2);\n");
      out.write("      } else {\n");
      out.write("         context.insertBefore(loadingBox2,context.firstChild);\n");
      out.write("      }\n");
      out.write("   }\n");
      out.write("}");
   }
   
   @Override
   public void jsFinish(Writer out) throws IOException {
      out.write("function () {\n");
      out.write("   var contextLI = document.getElementById(" + StringUtil.jsQuote(contextId + "LI") + ");\n");
      out.write("   if (contextLI != undefined) {\n");
      out.write("      contextLI.parentNode.removeChild(contextLI);\n");
      out.write("   }\n");
      out.write("}");
   }
}
