package com.getsnappy.util;

import java.lang.reflect.Constructor;
import java.lang.reflect.Method;
import java.util.HashMap;
import java.util.Map;

public class ReflectionCache
{
   public static class ClassCache {
      public static Map<String, Class> classCache = new HashMap<String, Class>();
      public static Class forName(String className) throws ClassNotFoundException {
         Class result = classCache.get(className);
         if (result == null) {
            result = Class.forName(className);
         }
         return result;
      }
      
      
   }

   public static class MethodCache {
       public static Map<Class, Map<String, Method>> methodCache = new HashMap<Class, Map<String, Method>>();
       public static Method getMethod(Class l_Class, String methodName, Class... parameters) throws SecurityException, NoSuchMethodException {
          Method result = null;
          String key = methodName;
          
          for (int i = 0;i < parameters.length;i++) {
             if (i == 0) { 
                key += '('; 
             } else {
                key += ", ";
             }
                
             key += parameters[0].getName();
                
             if (i == parameters.length - 1) {
                key += ')';
             }
          }
          Map<String, Method> iMethodCache = methodCache.get(l_Class);
          if (iMethodCache == null) {
             iMethodCache = new HashMap<String, Method>();
             methodCache.put(l_Class, iMethodCache);
          }
          
          result = iMethodCache.get(key);
          if (result == null) {
             result = l_Class.getMethod(methodName, parameters);
             iMethodCache.put(key,result);
          }
          return result;
       }
   }

   public static class ConstructorCache {
      public static Map<Class, Map<String, Constructor>> constructorCache = new HashMap<Class, Map<String, Constructor>>();
      public static Constructor getConstructor(Class l_Class, Class... parameters) throws SecurityException, NoSuchMethodException {
         Constructor result = null;
         String key = "";
         
         for (int i = 0;i < parameters.length;i++) {
            if (i == 0) { 
               key += '('; 
            } else {
               key += ", ";
            }
               
            key += parameters[0].getName();
               
            if (i == parameters.length - 1) {
               key += ')';
            }
         }
         Map<String, Constructor> iConstructorCache = constructorCache.get(l_Class);
         if (iConstructorCache == null) {
            iConstructorCache = new HashMap<String, Constructor>();
            constructorCache.put(l_Class, iConstructorCache);
         }
         
         result = iConstructorCache.get(key);
         if (result == null) {
            result = l_Class.getConstructor(parameters);
            iConstructorCache.put(key,result);
         }
         return result;
      }
  }

}
